#ifndef __LFGROUP_H__
#define __LFGROUP_H__

#include <lf/LFwindow.h>
#include <lf/LFarray.h>

class LFgroup;
class LFgroupItem;

class LFarrayGroup : public LFarrayBase
{
public:
            LFarrayGroup(long nItem);
            LFgroupItem *  operator [] (long  item);
};

class LFgroupItem : public LFobject
{
public:
            LFgroupItem(LFgroup *groupParent,LFgroup  *group,long groupflag=0,
                    long stretchFac=0,long border=0,long x=-1,long y=-1,long cx=-1,long cy=-1);
            LFgroupItem(LFgroup *groupParent,LFwindow *win,long groupflag=0,
                    long stretchFac=0,long border=0,long x=-1,long y=-1,long cx=-1,long cy=-1);
            LFgroupItem(LFgroup *groupParent,long groupflag=0,
                    long stretchFac=0,long border=0,long x=-1,long y=-1,long cx=-1,long cy=-1);


            void           ReSize(long x=-1,long y=-1,long cx=-1,long cy=-1,bool refresh=true);
    virtual ~LFgroupItem();
            long           m_x;
            long           m_y;
            long           m_cx;
            long           m_cy;
            long           m_groupflag;
            long           m_border;
            long           m_stretchFac;
            LFgroup       *m_groupParent;
            LFgroup       *m_group;
            LFwindow      *m_win;
            int            m_typeItem;
};

class LFgroup : public LFobject
{
public:
            LFgroup(long nItem=20,long type=LFVERTICAL,long x=0,long y=0,long cx=0,long cy=0);
    virtual ~LFgroup();
    
            LFgroupItem *  Add(LFgroup  *group,long groupflag=0,long border=0,
                              long stretchFac=0,long x=-1,long y=-1,long cx=-1,long cy=-1);
            LFgroupItem *  Add(LFwindow *win,long groupflag=0,long border=0,
                              long stretchFac=0,long x=-1,long y=-1,long cx=-1,long cy=-1);
            LFgroupItem *  Add(long cx,long cy,long groupflag=0,long border=0,
                              long stretchFac=0,long x=-1,long y=-1);
            void           ReCalc(LFwindow *win,bool refresh=true);
            void           ReCalc(LFgroup  *group,bool refresh=true);
            void           ReCalc(long x=-1,long y=-1,long cx=-1,long cy=-1,bool refresh=true);
            void           VwXReCalc(LFwindow *win,bool refresh=true);
            void           VwXReCalc(LFgroup  *group,bool refresh=true);
            void           VwXReCalc(long x=-1,long y=-1,long cx=-1,long cy=-1,bool refresh=true);
            void           EnableVwXresize(bool enable=true);
            void           Enable(bool enable=true);
            RECT           GetRect();
protected:
            long           MaxCX();
            long           MaxCY();
            long           MaxS();
            long           m_x;
            long           m_y;
            long           m_cx;
            long           m_cy;
            long           m_type;
            bool           m_enableVwXresize;
            bool           m_enable;
            LFarrayGroup   m_item;
};



#endif

