#ifndef __LFLIST_H__
#define __LFLIST_H__

#include <lf/LFobject.h>

class LFlist;
class LFnode;

class LFnode : public LFobject
{
 public:
                       LFnode(LFobject *object=LFNULL,LFnode *previous=LFNULL,
                              LFnode *next=LFNULL);
            LFnode     *m_previous;
            LFnode     *m_next;
            LFobject   *m_object;
};

class LFlist : public LFobject
{
 public:
                       LFlist();
   virtual             ~LFlist();
            LFnode *   Append(LFobject *LFobj);
            LFnode *   Insert(long nItem,LFobject *LFobj);
            LFobject * Delete(long nItem);
            LFobject * Delete(LFnode *node);
            LFobject * Delete(LFobject *LFobj);
            LFobject * GetNodeObject(LFnode *node);
            void       Clear();
            LFnode *   GetFirst();
            LFnode *   GetLast();
            LFnode *   GetPrevious(LFnode *node=LFNULL);
            LFnode *   GetNext(LFnode *node=LFNULL);
            long       GetCount();
            void       DeleteDataObject(bool delobj=false){m_delobj=delobj;}
            LFnode *   FindObject(LFobject *LFobj);
 protected:
            LFobject * DeleteNode(LFnode *node);
            LFnode     *m_list;
            LFnode     *m_listEnd;
            LFnode     *m_listSel;
            long       m_count;
            bool       m_delobj;
};

#endif
