#ifndef __LFWINDOW_H__
#define __LFWINDOW_H__

#include <lf/LFobject.h>
#include <lf/LFevent.h>
#include <windows.h>

#define maxId 2000


class LFwindow : public LFobject
{
 public:
                      LFwindow();
   virtual           ~LFwindow();
 
   virtual POINT      GetPosition();
   virtual void       SetPosition(POINT &pos);

   virtual void       SetRect(int x,int y,int cx,int cy,bool refresh=true);
   virtual void       SetRect(RECT &rect,bool refresh=true);
   virtual RECT       GetRect();   
   virtual RECT       GetClientRect();   

   virtual void       Refresh();
   virtual void       Show(long show=SW_SHOWNORMAL);
   virtual void       Enable(bool enabled=true);
   virtual void       SetText(const char* text);
   virtual long       GetCountText();
   virtual long       GetText(char *text,long lenght);
           WNDPROC    GetPrevWndProc(){return m_lpPrevWndProc;}
           HWND       GetHwnd();
           LFwindow * GetParent();
           LFwindow * GetGrandParent();
           void       Centre();
           
   virtual void       CaptureEvent();
   virtual void       RemoveCaptureEvent();

   virtual void       SetWindowProcEvent(bool eventProc);
   virtual LFwindow * GetWindowProcEvent();
   virtual bool       IsWindowProcEvent();

   static  int        NewWinId(){return --m_id;}
   virtual void       SetType(long type);
   virtual long       GetType();
 protected:
           HWND       m_hwnd;  
           POINT      m_pos;
           long       m_idWin;
           WNDPROC    m_lpPrevWndProc;
           LFwindow * m_parent;
           RECT       m_rect;
           bool       m_eventProc;
           long       m_type;
   static  long       m_id;
    
};

class LFwindowPanel : public LFwindow
{
 public:
   virtual LRESULT    WinProc(LFevent &event);
   virtual LRESULT    ControlWinProc(LFevent &event);
           LFwindow * GetLFwinCall(){return LFwinCall;}
           void       SetLFwinCall(LFwindow *LFwin){LFwinCall=LFwin;}

 protected:
           LFwindow   *LFwinCall;

};
 
#endif

