
#include <lf/LFarray.h>

LFobject * LFarray::operator [] (long  item)
{
    return m_item[item];
}

LFarray::LFarray(long nItem):LFarrayBase(nItem)
{
    
}

LFarrayBase::LFarrayBase(long nItem)
{
    m_count=nItem;
    m_item=new LFobject*[nItem] ;
    m_last=-1;
    for(int i=0;i < nItem;++i){
        m_item[i]=0;
    } 
}

LFarrayBase::~LFarrayBase()
{
    delete [] m_item;
}

LFobject * LFarrayBase::GetItemObject(long item)
{
    return m_item[item];
}


void LFarrayBase::Compact()
{
    int i=1,tmpZ=-1;
    while(i <= (m_count-1)){
        if(m_item[i] != 0){
            if(tmpZ != -1){
                m_item[tmpZ] = m_item[i];
                m_item[i]    = 0;
                m_last       = tmpZ;
                tmpZ         = tmpZ + 1;
            }
        }else{
            if(tmpZ==-1)tmpZ=i;
        }
        ++i;
    }
}


long LFarrayBase::Add(LFobject *item,long pos)
{
    if(pos != -1){
        if(pos == (m_count - 1))return LFnull;
        m_item[pos]=item;
        if(pos > m_last)m_last=pos;
    } else {
            if(m_last == (m_count - 1))return LFnull;
            m_item[++m_last]=item;
        }
    return m_last;
}

long LFarrayBase::GetLast()
{
    return m_last;
}


long LFarrayBase::GetCount()
{
    return m_count;
}


