
#include <lf/LFgroup.h>


LFgroupItem * LFarrayGroup::operator [] (long  item)
{
    return (LFgroupItem *)m_item[item];
}


LFarrayGroup::LFarrayGroup(long nItem):LFarrayBase(nItem)
{
    
}


LFgroupItem::LFgroupItem(LFgroup *groupParent,LFgroup  *group,long groupflag,long border,long stretchFac,long x,long y,long cx,long cy)
{
    RECT recTmp   = group->GetRect();
    m_x           = recTmp.left;
    m_y           = recTmp.top;
    m_cx          = recTmp.right; 
    m_cy          = recTmp.bottom;

    if(x  != -1)  m_x  = x;
    if(y  != -1)  m_y  = y;
    if(cx != -1)  m_cx = cx;
    if(cy != -1)  m_cy = cy;

    m_typeItem    = 0;
    m_border      = border;
    m_stretchFac  = stretchFac;
    m_groupflag   = groupflag;
    m_groupParent = groupParent;
    m_group       = group;
 
} 


LFgroupItem::LFgroupItem(LFgroup *groupParent,LFwindow *win,long groupflag,long border,long stretchFac,long x,long y,long cx,long cy)
{
    RECT recTmp   = win->GetRect();
    m_x           = recTmp.left;
    m_y           = recTmp.top;
    m_cx          = recTmp.right; 
    m_cy          = recTmp.bottom;

    if(x  != -1)  m_x  = x;
    if(y  != -1)  m_y  = y;
    if(cx != -1)  m_cx = cx;
    if(cy != -1)  m_cy = cy;

    m_typeItem    = 1;
    m_border      = border;
    m_stretchFac  = stretchFac;
    m_groupflag   = groupflag;
    m_groupParent = groupParent;
    m_win         = win;
}


LFgroupItem::LFgroupItem(LFgroup *groupParent,long groupflag,long border,long stretchFac,long x,long y,long cx,long cy)
{

    m_x           = x;
    m_y           = y;
    m_cx          = cx; 
    m_cy          = cy;
     
    m_typeItem    = 2;
    m_border      = border;
    m_stretchFac  = stretchFac;
    m_groupflag   = groupflag;
    m_groupParent = groupParent;
}


LFgroupItem::~LFgroupItem()
{
    
}


void LFgroupItem::ReSize(long x,long y,long cx,long cy,bool refresh)
{
    if(x  != -1) m_x  = x;
    if(y  != -1) m_y  = y;
    if(cx != -1) m_cx = cx;
    if(cy != -1) m_cy = cy;

    if(m_typeItem == 0){
        m_group->ReCalc(m_x,m_y,m_cx,m_cy,refresh);
    }
    if(m_typeItem == 1){
        m_win->SetRect(m_x,m_y,m_cx,m_cy,refresh);
    }
    
}


LFgroup::LFgroup(long nItem,long type,long x,long y,long cx,long cy):
                m_item(nItem)
{
    m_x               = x;
    m_y               = y;
    m_cx              = cx; 
    m_cy              = cy;
    m_type            = 0;
    m_enableVwXresize = true;
    m_enable          = true;

    if(type & LFVERTICAL) m_type=LFVERTICAL;
    if((type & LFHORIZONTAL) && (m_type == 0)) m_type=LFHORIZONTAL;
    if(m_type == 0 ) m_type = LFVERTICAL;

}


void LFgroup::Enable(bool enable)
{
    m_enable=enable;
}


void LFgroup::EnableVwXresize(bool enable)
{
    m_enableVwXresize=enable;
}


LFgroup::~LFgroup()
{

}



LFgroupItem * LFgroup::Add(LFgroup  *group,long groupflag,long border,
                       long stretchFac,long x,long y,long cx,long cy)
{
    LFgroupItem * itTmp;
    itTmp=new LFgroupItem(this,group,groupflag,border,stretchFac,x,y,cx,cy);
    m_item.Add(itTmp);
    return itTmp;
}

 
LFgroupItem * LFgroup::Add(LFwindow *win,long groupflag,long border,
                       long stretchFac,long x,long y,long cx,long cy)
{
    LFgroupItem * itTmp;
    itTmp=new LFgroupItem(this,win,groupflag,border,stretchFac,x,y,cx,cy);
    m_item.Add(itTmp);
    return itTmp;
}


LFgroupItem * LFgroup::Add(long cx,long cy,long groupflag,  
                       long border,long stretchFac,long x,long y)
{
    LFgroupItem * itTmp;
    if(x  != -1) m_x  = 0;
    if(y  != -1) m_y  = 0;
    itTmp=new LFgroupItem(this,groupflag,border,stretchFac,x,y,cx,cy);
    m_item.Add(itTmp);
    return itTmp;
}


void LFgroup::VwXReCalc(long x,long y,long cx,long cy,bool refresh)
{
    if(!m_enableVwXresize) return;
    ReCalc(x,y,cx,cy,refresh);
}


void LFgroup::VwXReCalc(LFwindow *win,bool refresh)
{
  if(!m_enableVwXresize) return;
  ReCalc(win,refresh);
}
void LFgroup::VwXReCalc(LFgroup  *group,bool refresh)
{
  if(!m_enableVwXresize) return;
  ReCalc(group,refresh);
}

void LFgroup::ReCalc(LFwindow *win,bool refresh)
{
  RECT rec=win->GetRect();
  ReCalc(0,0,rec.right,rec.bottom,refresh);
}
void LFgroup::ReCalc(LFgroup  *group,bool refresh)
{
  RECT rec=group->GetRect();
  ReCalc(0,0,rec.right,rec.bottom,refresh);
}

void LFgroup::ReCalc(long x,long y,long cx,long cy,bool refresh)
{
    if(!m_enable) return;
    if(x != -1)   m_x  = x;
    if(y != -1)   m_y  = y;
    if(cx != -1)  m_cx = cx;
    if(cy != -1)  m_cy = cy;
    
    int bx,by,bcx,bcy;
    long addx=0,addy=0,addxA=0,addyA=0;
    long addCHx,addCVx;
    long streSiz=0,maxStmp;
    
    if(m_type & LFVERTICAL)   streSiz=m_cy - MaxCY();
    if(m_type & LFHORIZONTAL) streSiz=m_cx - MaxCX();
    
    maxStmp = MaxS();
    if(maxStmp > 0)streSiz = streSiz / maxStmp;

    for(int i=0;i <= m_item.GetLast();++i){
        addxA=0;addyA=0;
        addCHx=0,addCVx=0;
        bx=0,by=0,bcx=0,bcy=0;

        if(m_item[i]->m_groupflag & LFBORDERLEFT)    bx = m_item[i]->m_border;
        if(m_item[i]->m_groupflag & LFBORDERTOP)     by = m_item[i]->m_border;
        if(m_item[i]->m_groupflag & LFBORDERRIGHT)  bcx = m_item[i]->m_border;
        if(m_item[i]->m_groupflag & LFBORDERBOTTOM) bcy = m_item[i]->m_border;

        if(m_item[i]->m_groupflag & LFTOP)
        {
            if(m_type & LFHORIZONTAL)addyA=m_y;
        }
        if(m_item[i]->m_groupflag & LFBOTTOM)
        {
            if(m_type & LFHORIZONTAL)addyA=m_cy - m_item[i]->m_cy - (bcy*2);
        }

        if(m_item[i]->m_groupflag & LFLEFT)
        {
            if(m_type & LFVERTICAL)addxA=m_x;
        }
        if(m_item[i]->m_groupflag & LFRIGHT)
        {
            if(m_type & LFVERTICAL)addxA=m_cx - m_item[i]->m_cx - (bcx*2);
        }

        if((!(m_item[i]->m_groupflag & LFBOTTOM)) &&
           ((m_item[i]->m_groupflag & LFCENTREV)  && (m_type & LFHORIZONTAL))){
              addCVx = (m_cy - m_item[i]->m_cy - by - bcy) / 2 ;
        }

        if((!(m_item[i]->m_groupflag & LFRIGHT))  && 
           ((m_item[i]->m_groupflag & LFCENTREH)  && (m_type & LFVERTICAL))){
              addCHx = (m_cx - m_item[i]->m_cx - bx - bcx) / 2 ;
        } 

        if(m_item[i]->m_groupflag & LFMAXSIZE)
        {   addxA=0;addyA=0; 
            if(m_type & LFVERTICAL)   m_item[i]->m_cx = m_cx - bcx - bcx;
            if(m_type & LFHORIZONTAL) m_item[i]->m_cy = m_cy - bcy - bcy;
        }

        if(m_type & LFVERTICAL  )addyA=0;
        if(m_type & LFHORIZONTAL)addxA=0;


        if(m_item[i]->m_stretchFac > 0 ) {
            if(m_type & LFVERTICAL  ){
                addyA=0;
                m_item[i]->m_cy = streSiz * m_item[i]->m_stretchFac;
            }
            if(m_type & LFHORIZONTAL){
                addxA=0;
                m_item[i]->m_cx = streSiz * m_item[i]->m_stretchFac;
            }
        }

        m_item[i]->ReSize(m_x + addCHx + addx + addxA + bx,m_y + addCVx + addy + addyA + by,-1,-1,refresh);

        if(m_type & LFHORIZONTAL){
            addx = addx + m_item[i]->m_cx + bcx + bx;            
        }
        if(m_type & LFVERTICAL  ){
            addy = addy + m_item[i]->m_cy + bcy + by;
        }
    }
}
 

long LFgroup::MaxCX()
{
    long tmpcx=0,bx,bcx;
    for(int i=0;i <= m_item.GetLast();++i){
        bx=0;bcx=0;
        if(m_item[i]->m_groupflag & LFBORDERLEFT)    bx = m_item[i]->m_border;
        if(m_item[i]->m_groupflag & LFBORDERRIGHT)  bcx = m_item[i]->m_border;
        if(m_item[i]->m_stretchFac == 0){tmpcx =tmpcx + m_item[i]->m_cx;}
        tmpcx =tmpcx + bcx + bx;
    }
    return tmpcx;
}
 

long LFgroup::MaxCY()
{
    long tmpcy=0,by,bcy;
    for(int i=0;i <= m_item.GetLast();++i){
        by=0;bcy=0;
        if(m_item[i]->m_groupflag & LFBORDERTOP)     by = m_item[i]->m_border;
        if(m_item[i]->m_groupflag & LFBORDERBOTTOM) bcy = m_item[i]->m_border;
        if(m_item[i]->m_stretchFac == 0){tmpcy =tmpcy + m_item[i]->m_cy;}
        tmpcy =tmpcy + bcy + by;
    }
    return tmpcy;
}


long LFgroup::MaxS()
{
    long tmpst=0;
    for(int i=0;i <= m_item.GetLast();++i){
        tmpst = tmpst + m_item[i]->m_stretchFac;
    }
    return tmpst;
}


RECT LFgroup::GetRect()
{
    RECT rec;
    rec.left   = m_x;
    rec.top    = m_y;
    rec.right  = m_cx;
    rec.bottom = m_cy;
    return rec;
}

