#include <lf/LFapp.h>
#include <lf/LFlistbase.h> 


LFlistbase::LFlistbase(LFwindow *parent,long id,const char * control,int x,int y,int width,
                     int height,unsigned long style,unsigned long ExStyle):
           LFcontrol(parent,id,control,x,y,width,height,style,ExStyle)
{ 
    SetWindowProcEvent(false);
    if(control[0]=='L')
    {
        m_tipoLista     = 1;
        m_parAppend     = LB_ADDSTRING;
        m_parGetData    = LB_GETITEMDATA;
        m_parSetData    = LB_SETITEMDATA; 
        m_parInsert     = LB_INSERTSTRING;
        m_parDelete     = LB_DELETESTRING;
        m_parDeleteAll  = LB_RESETCONTENT;
        m_parCount      = LB_GETCOUNT;
        m_parSelItem    = LB_SETCURSEL;
        m_parGetSelItem = CB_GETCURSEL;
    }
    if(control[0]=='C')
    {
        m_tipoLista     = 2;
        m_parAppend     = CB_ADDSTRING;
        m_parGetData    = CB_GETITEMDATA;
        m_parSetData    = CB_SETITEMDATA; 
        m_parInsert     = CB_INSERTSTRING;
        m_parDelete     = CB_DELETESTRING;
        m_parDeleteAll  = CB_RESETCONTENT;
        m_parCount      = CB_GETCOUNT;
        m_parSelItem    = CB_SETCURSEL;
        m_parGetSelItem = CB_GETCURSEL;
    }
}


LFlistbase::~LFlistbase()
{
}


LRESULT LFlistbase::Append(const LFstring item,LFobject *data)
{
    return Append(item.c_str(),data);
}


LRESULT LFlistbase::Insert(const LFstring item,LFobject *data)
{
    return Insert(item.c_str(),data);
}


LRESULT LFlistbase::Insert(const char * item,LFobject *data)
{
    UINT id;
    id=SendMessage(m_hwnd, m_parInsert, 0,(LPARAM)item); 
    if(id)SendMessage(m_hwnd, m_parSetData,(WPARAM)id,(LPARAM)data); 
    return id;
}   

LRESULT LFlistbase::Append(const char * item,LFobject *data)
{
    UINT id;
    id=SendMessage(m_hwnd, m_parAppend, 0,(LPARAM)item); 
    SendMessage(m_hwnd, m_parSetData,(WPARAM)id,(LPARAM)data); 
    return id;
}   


LFobject * LFlistbase::GetData(UINT item)
{
    return (LFobject *)SendMessage(m_hwnd, m_parGetData,(WPARAM)item,0); 
}   


LRESULT LFlistbase::SetData(UINT item,LFobject *data)
{
    return SendMessage(m_hwnd, m_parSetData,(WPARAM)item,(LPARAM)data); 
}   



LRESULT LFlistbase::GetCount()
{
    return SendMessage(m_hwnd, m_parCount,0,0); 
}


void LFlistbase::Clear()
{
    SendMessage(m_hwnd, m_parDeleteAll,0,0); 
}


LRESULT LFlistbase::DeleteItem(UINT item)
{
    return SendMessage(m_hwnd, m_parDelete,(WPARAM)item,0); 
}   


LRESULT LFlistbase::Select(UINT item)
{
    return SendMessage(m_hwnd, m_parSelItem,(WPARAM)item,0L);
}

LRESULT LFlistbase::GetSelect()
{
    return SendMessage(m_hwnd, m_parGetSelItem,0,0);    
}


LRESULT LFlistbase::SelectItem(UINT item) // only listbox
{
    if(m_tipoLista == 1){return 0;}
    return SendMessage(m_hwnd, LB_SETSEL,(WPARAM)true,(LPARAM)item);     
}


LRESULT LFlistbase::GetSelectItem(UINT item) // only listbox
{
    if(m_tipoLista == 1){return 0;}
    return SendMessage(m_hwnd, LB_GETSEL,(WPARAM)item,0);    
}


