#include <lf/LFwindow.h>
#include <lf/LFapp.h>


long LFwindow::m_id = 2500;

LFwindow::LFwindow()
{

}
LFwindow::~LFwindow()
{
}

HWND LFwindow::GetHwnd()
{ 
    return m_hwnd;
}

void LFwindow::SetType(long type)
{
    m_type=type;
}

long LFwindow::GetType()
{
    return m_type;
}

LFwindow * LFwindow::GetParent()
{
    return m_parent;
}


LFwindow * LFwindow::GetGrandParent()
{
   if(m_parent==LFNULL)return this;else return m_parent->GetGrandParent();
}



POINT LFwindow::GetPosition()
{
    return m_pos; 
}
void LFwindow::SetPosition(POINT &pos)
{
    m_pos       = pos;
    m_rect.left = m_pos.x;
    m_rect.top  = m_pos.y;
    ::MoveWindow(m_hwnd,m_rect.left,m_rect.top,m_rect.right,m_rect.bottom,true);
}

void LFwindow::Centre()
{
    RECT rPar;
    if(GetParent()==LFNULL)
    {
        rPar.right  = ::GetSystemMetrics(SM_CXSCREEN);         
        rPar.bottom = ::GetSystemMetrics(SM_CYSCREEN);     
    }else{
        rPar        = GetParent()->GetRect();         
    }
    

    m_rect.left = (rPar.right  - m_rect.right ) / 2;
    m_rect.top  = (rPar.bottom - m_rect.bottom) / 2;

    ::MoveWindow(m_hwnd,m_rect.left,m_rect.top,m_rect.right,m_rect.bottom,true);
    m_pos.x     = m_rect.left;
    m_pos.y     = m_rect.top;
}

void LFwindow::Show(long show)
{
    ::ShowWindow(m_hwnd,show);
}

void LFwindow::Refresh()
{
    ::InvalidateRect(m_hwnd,LFNULL,true);
}


void LFwindow::Enable(bool enabled)
{
    ::EnableWindow(m_hwnd,enabled);
}

void LFwindow::SetRect(int x,int y,int cx,int cy,bool refresh)
{
    m_rect.left   = x;
    m_rect.top    = y;
    m_rect.right  = cx;
    m_rect.bottom = cy;
    
    ::MoveWindow(m_hwnd,m_rect.left,m_rect.top,m_rect.right,m_rect.bottom,refresh);
    
    m_pos.x       = m_rect.left;
    m_pos.y       = m_rect.top;
}

void LFwindow::SetRect(RECT &rect,bool refresh)
{
    m_rect  = rect;

    ::MoveWindow(m_hwnd,m_rect.left,m_rect.top,m_rect.right,m_rect.bottom,refresh);

    m_pos.x = m_rect.left;
    m_pos.y = m_rect.top;
}

RECT LFwindow::GetRect()
{
    ::GetWindowRect(m_hwnd,&m_rect);
    if(GetParent()!=LFnull){
        POINT pt;
        pt.x          = m_rect.left;
        pt.y          = m_rect.top;
        
        ScreenToClient(GetParent()->GetHwnd(),&pt);

        m_rect.left   = pt.x;
        m_rect.top    = pt.y;
        pt.x          = m_rect.right;
        pt.y          = m_rect.bottom;

        ScreenToClient(GetParent()->GetHwnd(),&pt);

        m_rect.right  = pt.x - m_rect.left;
        m_rect.bottom = pt.y-m_rect.top;
        m_pos.x       = m_rect.left;
        m_pos.y       = m_rect.top;
    }else{
        m_rect.right  = m_rect.right  - m_rect.left;
        m_rect.bottom = m_rect.bottom - m_rect.top;        
        m_pos.x       = m_rect.left;
        m_pos.y       = m_rect.top;
    }
    return m_rect;
}

RECT LFwindow::GetClientRect()
{
    RECT cltRect;

    ::GetClientRect(m_hwnd,&cltRect);

    cltRect.right  = cltRect.right  - cltRect.left;
    cltRect.bottom = cltRect.bottom - cltRect.top;        
    return cltRect;
}



void LFwindow::SetText(const char* text)
{
    ::SetWindowText(m_hwnd,text);
}  



long LFwindow::GetText(char *text,long lenghtBuf)
{
    return ::GetWindowText(m_hwnd,text,lenghtBuf);
}  

long LFwindow::GetCountText()
{
    return ::GetWindowTextLength(m_hwnd);
}

void LFwindow::CaptureEvent()
{
    m_lpPrevWndProc=(WNDPROC)::SetWindowLong(m_hwnd,GWL_WNDPROC,(long)ControlWindowProc);
}
void LFwindow::RemoveCaptureEvent()
{
    ::SetWindowLong(m_hwnd,GWL_WNDPROC,(long)m_lpPrevWndProc);
    m_lpPrevWndProc=LFNULL;
}


void LFwindow::SetWindowProcEvent(bool eventProc)
{
    m_eventProc = eventProc;
}


bool LFwindow::IsWindowProcEvent()
{
    return m_eventProc;
}


LFwindow * LFwindow::GetWindowProcEvent()
{
   if( m_eventProc       ) return this;
   if( m_parent != LFNULL) return m_parent->GetWindowProcEvent();
   return LFNULL;
}


LRESULT LFwindowPanel::ControlWinProc(LFevent &event)
{
    return ::CallWindowProc(LFwinCall->GetPrevWndProc(),event.hwnd,event.mess,event.wPar,event.lPar);
}


LRESULT LFwindowPanel::WinProc(LFevent &event)
{
    return ::DefWindowProc (event.hwnd, event.mess, event.wPar, event.lPar);
}


